c: Copyright (C) Daniel Stenberg, <daniel@haxx.se>, et al.
SPDX-License-Identifier: curl
Long: remote-name
Short: O
Help: Write output to a file named as the remote file
Category: important output
Example: -O https://example.com/filename
Added: 4.0
See-also: remote-name-all output-dir remote-header-name
Multi: append
---
Write output to a local file named like the remote file we get. (Only the file
part of the remote file is used, the path is cut off.)

The file is saved in the current working directory. If you want the file saved
in a different directory, make sure you change the current working directory
before invoking curl with this option or use --output-dir.

The remote file name to use for saving is extracted from the given URL,
nothing else, and if it already exists it is overwritten. If you want the
server to be able to choose the file name refer to --remote-header-name which
can be used in addition to this option. If the server chooses a file name and
that name already exists it is not overwritten.

There is no URL decoding done on the file name. If it has %20 or other URL
encoded parts of the name, they end up as-is as file name.

You may use this option as many times as the number of URLs you have.
